GDAL

- Main Page
- Related Pages
- Classes
- Files
- Download
- Issue Tracker

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | List of all members
OGRTriangle Class Reference

Triangle class. More...

`#include <ogr_geometry.h>`

Inheritance diagram for OGRTriangle:

## Public Member Functions
| OGRTriangle ()
| Constructor.
| OGRTriangle (const OGRPoint &p, const OGRPoint &q, const OGRPoint &r)
| Construct a triangle from points. More...
| OGRTriangle (const OGRTriangle &other)
| Copy constructor.
| OGRTriangle (const OGRPolygon &other, OGRErr &eErr)
| Constructs an OGRTriangle from a valid OGRPolygon. More...
OGRTriangle & | operator= (const OGRTriangle &other)
| Assignment operator. More...
virtual | ~OGRTriangle ()
| Destructor. More...
virtual const char * | getGeometryName () const CPL_OVERRIDE
| Fetch WKT name for geometry type. More...
virtual OGRwkbGeometryType | getGeometryType () const CPL_OVERRIDE
| Fetch geometry type. More...
virtual OGRErr | importFromWkb (unsigned char *, int=-1, OGRwkbVariant=wkbVariantOldOgc) CPL_OVERRIDE
| Assign geometry from well known binary data. More...
virtual OGRErr | addRingDirectly (OGRCurve *poNewRing) CPL_OVERRIDE
| Add a ring to a polygon. More...
Public Member Functions inherited from OGRPolygon
| OGRPolygon ()
| Create an empty polygon.
| OGRPolygon (const OGRPolygon &other)
| Copy constructor. More...
OGRPolygon & | operator= (const OGRPolygon &other)
| Assignment operator. More...
virtual OGRBoolean | hasCurveGeometry (int bLookForNonLinear=FALSE) const CPL_OVERRIDE
| Returns if this geometry is or has curve geometry. More...
virtual OGRGeometry * | getCurveGeometry (const char *const *papszOptions=NULL) const CPL_OVERRIDE
| Return curve version of this geometry. More...
virtual OGRGeometry * | getLinearGeometry (double dfMaxAngleStepSizeDegrees=0, const char *const *papszOptions=NULL) const CPL_OVERRIDE
| Return, possibly approximate, non-curve version of this geometry. More...
virtual OGRErr | PointOnSurface (OGRPoint *poPoint) const CPL_OVERRIDE
| This method relates to the SFCOM ISurface::get_PointOnSurface() method. More...
virtual int | WkbSize () const CPL_OVERRIDE
| Returns size of related binary representation. More...
virtual OGRErr | exportToWkb (OGRwkbByteOrder, unsigned char *, OGRwkbVariant=wkbVariantOldOgc) const CPL_OVERRIDE
| Convert a geometry into well known binary format. More...
virtual OGRErr | importFromWkt (char **) CPL_OVERRIDE
| Assign geometry from well known text data. More...
virtual OGRErr | exportToWkt (char **ppszDstText, OGRwkbVariant=wkbVariantOldOgc) const CPL_OVERRIDE
| Convert a geometry into well known text format. More...
virtual OGRPolygon * | CurvePolyToPoly (double dfMaxAngleStepSizeDegrees=0, const char *const *papszOptions=NULL) const CPL_OVERRIDE
| Return a polygon from a curve polygon. More...
OGRLinearRing * | getExteriorRing ()
| Fetch reference to external polygon ring. More...
const OGRLinearRing * | getExteriorRing () const
| Fetch reference to external polygon ring. More...
virtual OGRLinearRing * | getInteriorRing (int)
| Fetch reference to indicated internal ring. More...
virtual const OGRLinearRing * | getInteriorRing (int) const
| Fetch reference to indicated internal ring. More...
OGRLinearRing * | stealExteriorRing ()
| "Steal" reference to external polygon ring. More...
virtual OGRLinearRing * | stealInteriorRing (int)
| "Steal" reference to indicated interior ring. More...
OGRBoolean | IsPointOnSurface (const OGRPoint *) const
| Return whether the point is on the surface. More...
virtual void | closeRings () CPL_OVERRIDE
| Force rings to be closed. More...
Public Member Functions inherited from OGRCurvePolygon
| OGRCurvePolygon ()
| Create an empty curve polygon.
| OGRCurvePolygon (const OGRCurvePolygon &)
| Copy constructor. More...
OGRCurvePolygon & | operator= (const OGRCurvePolygon &other)
| Assignment operator. More...
virtual OGRGeometry * | clone () const CPL_OVERRIDE
| Make a copy of this object. More...
virtual void | empty () CPL_OVERRIDE
| Clear geometry information. More...
virtual OGRErr | transform (OGRCoordinateTransformation *poCT) CPL_OVERRIDE
| Apply arbitrary coordinate transformation to geometry. More...
virtual void | flattenTo2D () CPL_OVERRIDE
| Convert geometry to strictly 2D. More...
virtual OGRBoolean | IsEmpty () const CPL_OVERRIDE
| Returns TRUE (non-zero) if the object has no points. More...
virtual void | segmentize (double dfMaxLength) CPL_OVERRIDE
| Modify the geometry such it has no segment longer then the given distance. More...
virtual double | get_Area () const CPL_OVERRIDE
| Get the area of the surface object. More...
virtual int | getDimension () const CPL_OVERRIDE
| Get the dimension of this object. More...
virtual void | getEnvelope (OGREnvelope *psEnvelope) const CPL_OVERRIDE
| Computes and returns the bounding envelope for this geometry in the passed psEnvelope structure. More...
virtual void | getEnvelope (OGREnvelope3D *psEnvelope) const CPL_OVERRIDE
| Computes and returns the bounding envelope (3D) for this geometry in the passed psEnvelope structure. More...
virtual OGRBoolean | Equals (OGRGeometry *) const CPL_OVERRIDE
| Returns TRUE if two geometries are equivalent. More...
virtual OGRBoolean | Intersects (const OGRGeometry *) const CPL_OVERRIDE
| Do these features intersect? More...
virtual OGRBoolean | Contains (const OGRGeometry *) const CPL_OVERRIDE
| Test for containment. More...
virtual void | setCoordinateDimension (int nDimension) CPL_OVERRIDE
| Set the coordinate dimension. More...
virtual void | set3D (OGRBoolean bIs3D) CPL_OVERRIDE
| Add or remove the Z coordinate dimension. More...
virtual void | setMeasured (OGRBoolean bIsMeasured) CPL_OVERRIDE
| Add or remove the M coordinate dimension. More...
virtual OGRErr | addRing (OGRCurve *)
| Add a ring to a polygon. More...
OGRCurve * | getExteriorRingCurve ()
| Fetch reference to external polygon ring. More...
const OGRCurve * | getExteriorRingCurve () const
| Fetch reference to external polygon ring. More...
int | getNumInteriorRings () const
| Fetch the number of internal rings. More...
OGRCurve * | getInteriorRingCurve (int)
| Fetch reference to indicated internal ring. More...
const OGRCurve * | getInteriorRingCurve (int) const
| Fetch reference to indicated internal ring. More...
OGRCurve * | stealExteriorRingCurve ()
| "Steal" reference to external ring. More...
virtual void | swapXY () CPL_OVERRIDE
| Swap x and y coordinates. More...
Public Member Functions inherited from OGRGeometry
| OGRGeometry (const OGRGeometry &other)
| Copy constructor. More...
OGRGeometry & | operator= (const OGRGeometry &other)
| Assignment operator. More...
virtual int | getCoordinateDimension () const
| Get the dimension of the coordinates in this object. More...
int | CoordinateDimension () const
| Get the dimension of the coordinates in this object. More...
virtual OGRBoolean | IsValid () const
| Test if the geometry is valid. More...
virtual OGRBoolean | IsSimple () const
| Test if the geometry is simple. More...
OGRBoolean | Is3D () const
OGRBoolean | IsMeasured () const
virtual OGRBoolean | IsRing () const
| Test if the geometry is a ring. More...
OGRwkbGeometryType | getIsoGeometryType () const
| Get the geometry type that conforms with ISO SQL/MM Part3. More...
virtual void | dumpReadable (FILE *, const char *=NULL, char **papszOptions=NULL) const
| Dump geometry in well known text format to indicated output file. More...
virtual char * | exportToGML (const char *const *papszOptions=NULL) const
| Convert a geometry into GML format. More...
virtual char * | exportToKML () const
| Convert a geometry into KML format. More...
virtual char * | exportToJson () const
| Convert a geometry into GeoJSON format. More...
virtual GEOSGeom | exportToGEOS (GEOSContextHandle_t hGEOSCtxt) const CPL_WARN_UNUSED_RESULT
| Returns a GEOSGeom object corresponding to the geometry. More...
void | assignSpatialReference (OGRSpatialReference *poSR)
| Assign spatial reference to this object. More...
OGRSpatialReference * | getSpatialReference (void) const
| Returns spatial reference system for object. More...
OGRErr | transformTo (OGRSpatialReference *poSR)
| Transform geometry to new spatial reference system. More...
virtual OGRBoolean | Disjoint (const OGRGeometry *) const
| Test for disjointness. More...
virtual OGRBoolean | Touches (const OGRGeometry *) const
| Test for touching. More...
virtual OGRBoolean | Crosses (const OGRGeometry *) const
| Test for crossing. More...
virtual OGRBoolean | Within (const OGRGeometry *) const
| Test for containment. More...
virtual OGRBoolean | Overlaps (const OGRGeometry *) const
| Test for overlap. More...
virtual OGRGeometry * | Boundary () const CPL_WARN_UNUSED_RESULT
| Compute boundary. More...
virtual double | Distance (const OGRGeometry *) const
| Compute distance between two geometries. More...
virtual OGRGeometry * | ConvexHull () const CPL_WARN_UNUSED_RESULT
| Compute convex hull. More...
virtual OGRGeometry * | Buffer (double dfDist, int nQuadSegs=30) const CPL_WARN_UNUSED_RESULT
| Compute buffer of geometry. More...
virtual OGRGeometry * | Intersection (const OGRGeometry *) const CPL_WARN_UNUSED_RESULT
| Compute intersection. More...
virtual OGRGeometry * | Union (const OGRGeometry *) const CPL_WARN_UNUSED_RESULT
| Compute union. More...
virtual OGRGeometry * | UnionCascaded () const CPL_WARN_UNUSED_RESULT
| Compute union using cascading. More...
virtual OGRGeometry * | Difference (const OGRGeometry *) const CPL_WARN_UNUSED_RESULT
| Compute difference. More...
virtual OGRGeometry * | SymDifference (const OGRGeometry *) const CPL_WARN_UNUSED_RESULT
| Compute symmetric difference. More...
virtual OGRErr | Centroid (OGRPoint *poPoint) const
| Compute the geometry centroid. More...
virtual OGRGeometry * | Simplify (double dTolerance) const CPL_WARN_UNUSED_RESULT
| Simplify the geometry. More...
OGRGeometry * | SimplifyPreserveTopology (double dTolerance) const CPL_WARN_UNUSED_RESULT
| Simplify the geometry while preserving topology. More...
virtual OGRGeometry * | DelaunayTriangulation (double dfTolerance, int bOnlyEdges) const CPL_WARN_UNUSED_RESULT
| Return a Delaunay triangulation of the vertices of the geometry. More...
virtual OGRGeometry * | Polygonize () const CPL_WARN_UNUSED_RESULT
| Polygonizes a set of sparse edges. More...
virtual double | Distance3D (const OGRGeometry *poOtherGeom) const
| Returns the 3D distance between two geometries. More...

## Additional Inherited Members
Static Public Member Functions inherited from OGRGeometry
static GEOSContextHandle_t | createGEOSContext ()
| Create a new GEOS context. More...
static void | freeGEOSContext (GEOSContextHandle_t hGEOSCtxt)
| Destroy a GEOS context. More...
Static Protected Member Functions inherited from OGRCurvePolygon
static OGRPolygon * | CastToPolygon (OGRCurvePolygon *poCP)
| Convert to polygon. More...

## Detailed Description

Triangle class.

Since
  GDAL 2.2

## Constructor & Destructor Documentation

OGRTriangle::OGRTriangle | ( | const OGRPoint & | p,
|  | const OGRPoint & | q,
|  | const OGRPoint & | r
| ) |  |

Construct a triangle from points.

Parameters

  p | Point 1
  q | Point 2
  r | Point 3

OGRTriangle::OGRTriangle | ( | const OGRPolygon & | other,
|  | OGRErr & | eErr
| ) |  |

Constructs an OGRTriangle from a valid OGRPolygon.

In case of error, NULL is returned.

Parameters

  other | the Polygon we wish to construct a triangle from
  eErr | encapsulates an error code; contains OGRERR_NONE if the triangle is constructed successfully

OGRTriangle::~OGRTriangle | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

OGRErr OGRTriangle::addRingDirectly | ( | OGRCurve * | poNewRing | ) |
| virtual

Add a ring to a polygon.

If the polygon has no external ring (it is empty) this will be used as the external ring, otherwise it is used as an internal ring. Ownership of the passed ring is assumed by the OGRCurvePolygon, but otherwise this method operates the same as OGRCurvePolygon::AddRing().

This method has no SFCOM analog.

Parameters

  poNewRing | ring to be added to the polygon.

Returns
  OGRERR_NONE in case of success

Reimplemented from OGRCurvePolygon.

const char * OGRTriangle::getGeometryName | ( |  | ) | const
| virtual

Fetch WKT name for geometry type.

There is no SFCOM analog to this method.

This method is the same as the C function OGR_G_GetGeometryName().

Returns
  name used for this geometry type in well known text format. The returned pointer is to a static internal string and should not be modified or freed.

Reimplemented from OGRPolygon.

OGRwkbGeometryType OGRTriangle::getGeometryType | ( |  | ) | const
| virtual

Fetch geometry type.

Note that the geometry type may include the 2.5D flag. To get a 2D flattened version of the geometry type apply the wkbFlatten() macro to the return result.

This method is the same as the C function OGR_G_GetGeometryType().

Returns
  the geometry type code.

Reimplemented from OGRPolygon.

OGRErr OGRTriangle::importFromWkb | ( | unsigned char * | pabyData,
|  | int | nSize = `-1`,
|  | OGRwkbVariant | eWkbVariant = `wkbVariantOldOgc`
| ) |  |
| virtual

Assign geometry from well known binary data.

The object must have already been instantiated as the correct derived type of geometry object to match the binaries type. This method is used by the OGRGeometryFactory class, but not normally called by application code.

This method relates to the SFCOM IWks::ImportFromWKB() method.

This method is the same as the C function OGR_G_ImportFromWkb().

Parameters

  pabyData | the binary input data.
  nSize | the size of pabyData in bytes, or zero if not known.
  eWkbVariant | if wkbVariantPostGIS1, special interpretation is done for curve geometries code

Returns
  OGRERR_NONE if all goes well, otherwise any of OGRERR_NOT_ENOUGH_DATA, OGRERR_UNSUPPORTED_GEOMETRY_TYPE, or OGRERR_CORRUPT_DATA may be returned.

Reimplemented from OGRPolygon.

OGRTriangle & OGRTriangle::operator= | ( | const OGRTriangle & | other | ) |

Assignment operator.

Parameters

  other | A triangle passed as a parameter

Returns
  OGRTriangle A copy of other

The documentation for this class was generated from the following files:

- ogr_geometry.h
- ogrtriangle.cpp

Generated for GDAL by 1.8.9.1.